<?php

global $EG_SERIES_DEFAULT_OPTIONS;

$post_type_list = array();
if (function_exists('get_post_types')) {
	$custom_post_types = get_post_types(array(), 'object');
	$exclusion_list    = array('post', 'page', 'attachment', 'nav_menu_item', 'revision');

	$default_values    = array();
	foreach ($custom_post_types as $post_type_id => $post_type_value) {
		if (! in_array($post_type_id, $exclusion_list)) {
			$post_type_list[$post_type_id] = $post_type_value->label;
			if (in_array(EGS_TAXONOMY, $post_type_value->taxonomies))
				$default_values[] = $post_type_id;
		}
	} // End of foreach

	if (sizeof($default_values) >0)
		$EG_SERIES_DEFAULT_OPTIONS['custom_post_types'] = array_unique(array_merge($EG_SERIES_DEFAULT_OPTIONS['custom_post_types'], $default_values));
} // End of function get_post_types exists

$this->options_form = new EG_Form_210('egs_options', 'EG-Series Settings', $this->options_entry, $this->textdomain, '', '',
										array(&$this, 'display_sidebar'));

$shortcode_opts_id = $this->options_form->add_section(array(
			'tab'		=> 'shortcode',
			'title' 	=> 'Shortcodes options',
			'header'	=> 'You can choose keywords you want use for shortcodes.<br />Change them only just after the plugin installation. In other case, all EG-Series shortcodes already used in posts, won\'t work properly after the change.'
		)
);

	$this->options_form->add_field( array(
			'section'	=> $shortcode_opts_id,
			'name'		=> 'series_url',
			'label'		=> 'Link for series',
			'type'		=> 'radio',
			'before'	=> 'In versions 1.x of this plugin, url of series was the permalink of the first post of these series.<br />To stay compatible, versions 2.x, keep this behavior by default. You can choose to switch to the new mode: in this case, the url will lead to the page of the serie',
			'options'	=> array( 1 => 'Mode 1.x: url is the permalink of the first post of the serie',
			  2 => 'Mode 2.x: url is the link of the page of the serie'))
	);

	$this->options_form->add_field( array(
			'section'	=> $shortcode_opts_id,
			'name'		=> 'shortcode_list_series',
			'label'		=> 'List of series',
			'before'	=> 'Shortcode to display list of series',
			'desc'		=> 'Use to display list of series',
			'type'		=> 'text')
	);

	$this->options_form->add_field( array(
			'section'	=> $shortcode_opts_id,
			'name'		=> 'shortcode_list_posts',
			'label'		=> 'List of posts',
			'type'		=> 'text',
			'before'	=> 'Shortcode to display posts of a serie',
			'desc'		=> 'Use to list all posts of the same serie than the current post')
	);
	$this->options_form->add_field( array(
			'section'	=> $shortcode_opts_id,
			'name'		=> 'date_format',
			'label'		=> 'Date format',
			'type'		=> 'text',
			'size'		=> 'small',
			'after'		=> sprintf(__('Default value: %s (%s)', $this->textdomain),get_option('date_format'),date_i18n(get_option('date_format'))),
			'desc'		=> 'Use PHP <strong>date()</strong> parameters to configure the date:<br />d&nbsp;&nbsp;&nbsp;&nbsp;Day of the month, 2 digits with leading zeros<br />D&nbsp;&nbsp;&nbsp;&nbsp;A textual representation of a day, three letters<br />j&nbsp;&nbsp;&nbsp;&nbsp;Day of the month without leading zeros<br />S&nbsp;&nbsp;&nbsp;&nbsp;English ordinal suffix for the day of the month, 2 characters<br />F&nbsp;&nbsp;&nbsp;&nbsp;A full textual representation of a month, such as January or March<br />m&nbsp;&nbsp;&nbsp;&nbsp;Numeric representation of a month, with leading zeros<br />M&nbsp;&nbsp;&nbsp;&nbsp;A short textual representation of a month, three letters<br />n&nbsp;&nbsp;&nbsp;&nbsp;Numeric representation of a month, without leading zeros<br />Y&nbsp;&nbsp;&nbsp;&nbsp;A full numeric representation of a year, 4 digits<br />y&nbsp;&nbsp;&nbsp;&nbsp;A two digit representation of a year')
	);
	if (function_exists('get_post_types') && sizeof($post_type_list) > 0) {
		$this->options_form->add_field( array(
			'section'	=> $shortcode_opts_id,
			'name'		=> 'custom_post_types',
			'label'		=> 'Custom post types',
			'before'	=> 'You can use EG-Series with the following custom post types',
			'type'		=> 'checkbox',
			'options'   => $post_type_list)
		);
	}
$auto_shortcode_opts_id = $this->options_form->add_section( array(
		'nav'	=> 'autoshortcode',
		'title' => 'Auto shortcode')
);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto',
		'label'		=> 'Activation',
		'desc'		=> 'The option "Between excerpt and content" doesn\'t work if you use automatic excerpts. It works on with manual excerpt or with &lt!--more--&gt; tag. See the <a href="http://codex.wordpress.org/Excerpt" title="Excerpt in WordPress Codex">WordPress documentation</a> to get more details on excerpt.',
		'before'	=> 'Automatically add the list of posts that are in the same serie than the current displayed post: ',
		'type'		=> 'radio',
		'options'	=> array( 0 => 'Not activated', 2 => 'At the end', 3 => 'Before the excerpt', 4 => 'Between excerpt and content'))
	);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto_exclusive',
		'label'		=> 'Auto / Manual',
		'after'		=>  'Disable auto-shortcode when a manual shortcode is detected',
		'desc'		=> 'If this option is activated, auto shortcode won\'t be generated if a manual shortcode is detected in the post being displayed',
		'type'		=> 'checkbox')
	);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto_where',
		'label'		=> 'Where',
		'before'	=> 'Activate automatic shortcode only on the following cases',
		'type'		=> 'checkbox',
		'options'	=> array( 'home' => 'Homepage,', 'post' => 'Posts,', 'page' => 'Pages,', 'index' => 'Lists of posts (archives, categories, ...).', 'feed' => 'RSS/Atom Feeds'))
	);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto_title',
		'label'		=> 'Title of the list',
		'type'		=> 'text')
	);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto_title_tag',
		'label'		=> 'HTML Tag for title',
		'type'		=> 'text',
		'size'		=> 'small',
		'after'		=> '(tag like h2, or h3)')
	);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto_listtype',
		'label'		=> 'List type',
		'before'	=> 'Activate automatic shortcode only on the following cases',
		'type'		=> 'radio',
		'options'	=> array( 'select' => 'Select', 'ul' => 'Simple list', 'ol' => 'Ordered list'))
	);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto_orderby',
		'label'		=> 'Order by',
		'type'		=> 'select',
		'options'	=> array( 'date' => 'Date', 'title' => 'Title', 'menu_order' => 'User order'))
	);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto_order',
		'label'		=> 'Sort Order',
		'type'		=> 'select',
		'options'	=> array( 'ASC' => 'Ascending', 'DESC' => 'Descending'))
	);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto_show_date',
		'label'		=> 'Display dates',
		'type'		=> 'checkbox',
		'before'	=> 'Display dates?')
	);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto_expand',
		'label'		=> 'Display posts',
		'type'		=> 'checkbox',
		'before'	=> 'Display excerpt of posts?')
	);
	$this->options_form->add_field( array(
		'section'	=> $auto_shortcode_opts_id,
		'name'		=> 'shortcode_auto_default_opts',
		'label'		=> 'Default options',
		'type'		=> 'checkbox',
		'after'		=> 'Do you want that options of auto shortcode become the default options for the button EG-Series of posts editor?')
	);
	
$interface_section_id = $this->options_form->add_section( array( 'tab' => 'admin', 'title' => 'Interface'));
	$this->options_form->add_field( array(
			'section'	=> $interface_section_id,
			'name'		=> 'display_columns',
			'label'		=> 'Post management list',
			'after'		=> 'Add column \'Series\' to the post management page',
			'type'		=> 'checkbox')
	);
	$this->options_form->add_field( array(
			'section'	=> $interface_section_id,
			'name'		=> 'display_dashboard',
			'label'		=> 'Dashboard',
			'after'		=> 'Display number of series in the dashboard?',
			'type'		=> 'checkbox')
	);
	$this->options_form->add_field( array(
			'section'	=> $interface_section_id,
			'name'		=> 'access_level',
			'label'		=> 'Edit series',
			'before'	=>  'Give the required access level to users for editing series, and posts in series',
			'type'		=> 'radio',
			'options'	=> array(
				'manage_options'	=> 'Administrator',
				'manage_categories' => 'Editor',
				'publish_posts' 	=> 'Author',
				'edit_posts' 		=> 'Contributor'))
	);
	
	
$style_opts_id = $this->options_form->add_section( array(
		'nav'		=> 'admin',
		'title' 	=> 'Styles')
);
	$this->options_form->add_field( array(
		'section'	=> $style_opts_id,
		'name'		=> 'load_css',
		'label'		=> 'Stylesheet',
		'type'		=> 'checkbox',
		'after'		=> 'Automatically load plugins\' stylesheet',
		'desc'		=> 'Check if you want to use the plugin stylesheet file, uncheck if you want to use your own styles, or include styles on the theme stylesheet.')
	);

$uninstall_opts_id = $this->options_form->add_section( array(
		'nav'		=> 'admin',
		'title' 	=> 'Uninstall options',
		'footer'	=> 'Be careful: these actions cannot be cancelled. All plugin\'s options will be deleted while plugin uninstallation.')
);
	$this->options_form->add_field( array(
		'section'	=> $uninstall_opts_id,
		'name'		=> 'uninstall_del_options',
		'label'		=> 'Delete options',
		'type'		=> 'checkbox',
		'after'		=> 'Check if you want to delete options while plugin uninstallation')
	);
	$this->options_form->add_field( array(
		'section'	=> $uninstall_opts_id,
		'name'		=> 'uninstall_del_series',
		'label'		=> 'Delete series',
		'type'		=> 'checkbox',
		'after'		=> 'Check if you want to delete all series and taxonomy')
	);


?>