<?php

if ( ! class_exists('EG_Series_Series_Widget') ) {

	class EG_Series_Series_Widget extends EG_Widget_203 {

		var $default_values = FALSE;
		
		function EG_Series_Series_Widget() {
			global $EG_SERIES_SHORTCODE_SERIES_DEFAULTS;

			$widget_ops = array('classname' => 'widget_eg_series_series', 'description' => 'Display series or groups of posts' );
			$this->WP_Widget('EG_Bew_Series_Series_Widget', 'EG-Series List', $widget_ops);

			$fields = array(
					'title'		 => array( 'type' => 'text',  'label' => 'Title'),
					'listtype'	 => array( 'type' => 'select','label' => 'List format','list' => array(
											'select' => 'Select',
											'ul'     => 'Simple list',
											'ol' 	 => 'Ordered list')),
					'number' 	 => array( 'type' => 'numeric',  'label' => 'Number of series to display'),
					'numposts'	 => array( 'type' => 'checkbox', 'label' => 'Display number of posts?'),
					'hide_empty' => array( 'type' => 'checkbox', 'label' => 'Hide empty series (series with no posts)?'),
					'width' 	 => array( 'type' => 'numeric',  'label' => 'Width'),
					'more' 		 => array( 'type' => 'numeric',  'label' => 'Page or Post id where all series are displayed')
			);

			$default_values = array(
				'title' 		=> 'Series',
				'listtype' 		=> $EG_SERIES_SHORTCODE_SERIES_DEFAULTS['listtype'],
				'number'		=> $EG_SERIES_SHORTCODE_SERIES_DEFAULTS['number'],
				'width'			=> 0,
				'more'			=> $EG_SERIES_SHORTCODE_SERIES_DEFAULTS['more'],
				'numposts'		=> $EG_SERIES_SHORTCODE_SERIES_DEFAULTS['numposts'],
				'hide_empty'    => $EG_SERIES_SHORTCODE_SERIES_DEFAULTS['hide_empty']
			);

			$this->set_options(EGS_TEXTDOMAIN, EGS_CORE_FILE, 0 );
			$this->set_form($fields, $default_values, TRUE );

		} // End of constructor

		function widget($args, $instance) {

			extract($args, EXTR_SKIP);
			$values = wp_parse_args( (array) $instance, $this->default_values );

			$output = '';
			if ($this->is_visible($values)) {
				// Display list of series
				$plugin_options = get_option(EGS_OPTIONS_ENTRY);
				$output =  EG_Series_Core::series_list($plugin_options, 
														array_merge($values, array('auto_submit' => 1, 'listposts' => 0))
							);
			} // End of is_visible

			if ($output != '') {
				echo $before_widget.
					($values['title']!= ''?$before_title.htmlspecialchars(__($values['title'], $this->textdomain)).$after_title:'').
					$output.
					$after_widget;
			}
		} // End of function widget

	} // End of EG_Series_Series_Widget

} // End of class_exists EG_Series_Series_Widget

if (!class_exists('EG_Series_Posts_Widget')) {

	class EG_Series_Posts_Widget extends EG_Widget_203 {

		var $default_values = FALSE;
	
		function EG_Series_Posts_Widget() {
			global $EG_SERIES_SHORTCODE_POSTS_DEFAULTS;
		
			$widget_ops = array('classname' => 'widget_eg_series_posts', 'description' => 'Display posts of the same serie than the current post' );
			$this->WP_Widget('EG_Series_Posts_Widget', 'EG-Series Posts', $widget_ops);
			
			$fields = array(
					'title' 		 => array( 'type' => 'text',      'label' => 'Title'),
					'use_serie_name' => array( 'type' => 'checkbox',  'label' => 'or use serie name as title'),
					'listtype' 		 => array( 'type' => 'select',    'label' => 'List format', 'list' => array('select' => 'Select', 'ul' => 'Simple list', 'ol' => 'Ordered list')),
					'width' 		 => array( 'type' => 'numeric',   'label' => 'Width'),
					'orderby' 	     => array( 'type' => 'select',    'label' => 'Order by ', 'list' => array('title'  => 'Title','date' => 'Date', 'menu_order' => 'User order')),
					'order' 	     => array( 'type' => 'select',    'label' => 'Sort order', 'list' => array('ASC'  => 'Ascending','DESC' => 'Descending')),
					'show_date'      => array( 'type' => 'checkbox', 'label' => 'Show date'),
					'expand' 	      => array( 'type' => 'checkbox',  'label' => 'Show posts details')
			);

			$default_values = array(
					'title' 		  => 'Posts of the same serie',
					'use_serie_name'  => 0,
					'listtype'		  => $EG_SERIES_SHORTCODE_POSTS_DEFAULTS['listtype'],
					'width'			  => 0,
					'orderby'		  => $EG_SERIES_SHORTCODE_POSTS_DEFAULTS['orderby'],
					'order'	          => $EG_SERIES_SHORTCODE_POSTS_DEFAULTS['order'],
					'show_date'       => $EG_SERIES_SHORTCODE_POSTS_DEFAULTS['show_date'],
					'expand'          => $EG_SERIES_SHORTCODE_POSTS_DEFAULTS['expand']
				);

			$this->set_options(EGS_TEXTDOMAIN, EGS_CORE_FILE, 0 );
			$this->set_form($fields, $default_values, TRUE );

		} // End of cosntructor

		function widget($args, $instance) {

			extract($args, EXTR_SKIP);
			$values = wp_parse_args( (array) $instance, $this->default_values );

			$output = '';
			if ($this->is_visible($values) && is_singular() ) {

					// Get plugin options for post_type
					$plugin_options = get_option(EGS_OPTIONS_ENTRY);

					// Display list of posts
					$output = EG_Series_Core::posts_list($plugin_options, $values );

					if ($output != '') {
						if ($values['use_serie_name'] == 0) $widget_title = $values['title'];
						else {
							global $post;
							$terms = get_the_terms($post->ID, EGS_TAXONOMY );
							$serie = reset($terms);
							$widget_title = $serie->name;
						}

						echo $before_widget.
							($widget_title!= ''?$before_title.htmlspecialchars(__($widget_title, $this->textdomain)).$after_title:'').
							$output.
							$after_widget;
					}
			} // End of is_visible
		} // End of function widget

	} // End of EG_Series_Posts_Widget

} // End of class_exists EG_Series_Posts_Widget


function eg_series_widgets_init() {

	register_widget('EG_Series_Series_Widget');
	register_widget('EG_Series_Posts_Widget');

}
add_action('init', 'eg_series_widgets_init', 1);

?>